<?php

require_once("common.function.php");
init();

class ItemNode {

  // メンバ宣言
  var $dirName;
  var $dirPath;
  var $csvDirPath;
  var $csvFilesPath;

  // コンストラクタ宣言
  function ItemNode($dn,$dp,$cdp,$cfp) {
    $this->dirName = $dn;
    $this->dirPath = $dp;
    $this->csvDirPath   = $cdp;
    $this->csvFilesPath = $cfp;
  }

  // メソッド宣言
  function ItemList() {

    //ディレクトリを配列に格納
    $dirList["data1"] = array();
    $dirItem = scandir($this->dirPath);
    foreach($dirItem as $value) {
      if (is_dir($this->dirPath.$value) && $value != "." && $value != ".." && preg_match("/^[!-~]+$/", $value)){
        array_push($dirList["data1"], $value);
      }
    }

    //ディレクトリ内のファイルを配列で取得
    $fileList["data1"] = array();
    for($i=0; $i<count($dirList["data1"]); $i++){
      $fileList["data1"][$i] = scandir($this->dirPath.$dirList["data1"][$i]);
    }

    //ディレクトリ内の画像ファイルの有無をチェック
    $dirList["data2"] = array();
    for($i=0; $i<count($fileList["data1"]); $i++){
      foreach($fileList["data1"][$i] as $value) {
        if ($value != "." && $value != ".." && preg_match("/^[!-~]+$/", $value) && Eregi('jpg$', $value) || Eregi('jpeg$', $value) || Eregi('gif$', $value) || Eregi('png$', $value)){
          $valueChk = $this->dirPath.$dirList["data1"][$i]."/".$value;
          list(,,$t,) = getimagesize($valueChk);
          if ($t < 4){
            $flg[$i] = true;
            break;
          }
        }
      }
      if($flg[$i]){
        array_push($dirList["data2"],$dirList["data1"][$i]);
      }
    }

    //画像が存在するディレクトリ内のファイルを配列で取得
    $fileList["data2"] = array();
    for($i=0; $i<count($dirList["data2"]); $i++){
      $fileList["data2"][$i] = scandir($this->dirPath.$dirList["data2"][$i]);
    }

    //画像が存在するディレクトリ内の画像ファイルの有無をチェック
    $fileList["data3"] = array();
    for($i=0; $i<count($fileList["data2"]); $i++){
      $fileList["data3"][$i] = array();
      foreach($fileList["data2"][$i] as $value) {
        if ($value != "." && $value != ".." && preg_match("/^[!-~]+$/", $value) && Eregi('jpg$', $value) || Eregi('jpeg$', $value) || Eregi('gif$', $value) || Eregi('png$', $value)){
          $valueChk = $this->dirPath.$dirList["data2"][$i]."/".$value;
          list(,,$t,) = getimagesize($valueChk);
          if ($t < 4){
            array_push($fileList["data3"][$i],$value);
          }
        }
      }
    }

    //ディレクトリCSV読込
    $row1   = 0;
    $csvDir = array();
    $csvDir["data1"] = array();
    $handle = fopen($this->csvDirPath,"r");
    while(($tmp = fgetcsv_reg($handle)) !== FALSE){
      $csvDir["data1"][$row1]["dir"]  = convertEnc(htmlSpc($tmp[0]));
      $csvDir["data1"][$row1]["name"] = convertEnc(htmlSpc($tmp[1]));
      $row1++;
    }
    fclose($handle);

    //ディレクトリCSV配列からディレクトリが存在しない行を排除
    $csvDir["data2"] = array();
    $row2 = 0;
    for($i=0; $i <= $row1; $i++){
      for($j=0; $j < count($dirList["data2"]); $j++){
        if($csvDir["data1"][$i]["dir"] == $dirList["data2"][$j]){
          $csvDir["data2"][$row2]["dir"]  = $csvDir["data1"][$i]["dir"];
          $csvDir["data2"][$row2]["name"] = $csvDir["data1"][$i]["name"];
          $row2++;
        }
      }
    }

    //ディレクトリCSV配列を参照して配列をソート
    $flg1 = array();
    $row3 = count($csvDir["data2"]);
    for($i=0; $i < count($dirList["data2"]); $i++){
      $flg1[$i] = false;
      for($j=0; $j < count($csvDir["data2"]); $j++){
        if($dirList["data2"][$i] == $csvDir["data2"][$j]["dir"]){
          if($csvDir["data2"][$j]["name"] != ""){
            $this->dirListName[$j] = $csvDir["data2"][$j]["name"];
          } else {
            $this->dirListName[$j] = $dirList["data2"][$i];
          }
          $this->dirListRslt[$j]  = $csvDir["data2"][$j]["dir"];
          $this->fileListRslt[$j] = $fileList["data3"][$i];
          $flg1[$i] = true;
        }
      }
      if(!$flg1[$i]){
        $this->dirListName[$row3]  = $dirList["data2"][$i];
        $this->dirListRslt[$row3]  = $dirList["data2"][$i];
        $this->fileListRslt[$row3] = $fileList["data3"][$i];
        $row3++;
      }
    }

    //ファイルCSVを読込
    $csvFiles = array();
    $row4   = 0;
    $csvFiles["data1"] = array();
    $handle = fopen($this->csvFilesPath,"r");
    while(($tmp = fgetcsv_reg($handle)) !== FALSE){
      $csvFiles["data1"]["dir"][$row4]  = convertEnc(htmlSpc($tmp[0]));
      $csvFiles["data1"]["name"][$row4] = convertEnc(htmlSpc($tmp[1]));
      $csvFiles["data1"]["dscr"][$row4] = convertEnc(htmlSpc($tmp[2]));
      $row4++;
    }
    fclose($handle);

    //ファイルCSV配列を参照して配列をソート
    $row5 = array();
    for($i=0; $i < count($this->fileListRslt); $i++){
      $row5[$i] = 0;
      for($k=0; $k < $row4; $k++){
        for($j = 0; $j < count($this->fileListRslt[$i]); $j++){
          if($csvFiles["data1"]["name"][$k] == $this->fileListRslt[$i][$j]) {
            if($csvFiles["data1"]["dir"][$k] == $this->dirListRslt[$i] || $csvFiles["data1"]["dir"][$k] == $this->dirListName[$i]){
              $this->fileListName[$i][$row5[$i]]  = $csvFiles["data1"]["name"][$k];
              $this->fileListDsrc[$i][$row5[$i]]  = nl2br($csvFiles["data1"]["dscr"][$k]);
              $this->fileListBool[$i][$j] = true;
              $row5[$i]++;
            }
            break;
          }
        }
      }
    }

    //ファイルCSV配列に無いファイルを後置
    $row6 = array();
    for($i=0; $i < count($this->fileListRslt); $i++){
      $row6 = $row5[$i];
      for($j = 0; $j < count($this->fileListRslt[$i]); $j++){
        if(!$this->fileListBool[$i][$j]){
          $this->fileListName[$i][$row6]  = $this->fileListRslt[$i][$j];
          $this->fileListDsrc[$i][$row6]  = null;
          $row6++;
        }
      }
    }

  }
} // END ItemNode

?>